/*******************************************************************
 * Temporisateur décompteur double usage suivant le câblage effectué *
 * Soit simple timer avec beep de fin de décompte soit commande de   *
 * relais pour couper une charge connectée ...                       *
 ********************************************************************/
byte power_pin = 7; // Maintient du relais d'alimentation 
byte sw_sel = 6;// Validation par appui sur le bouton du codeur...
byte sw_up = 5;// Incrémentation menu sens montée
byte sw_dwn = 4;//  Décrémentation menu sens descente
byte buz_beep = 9;//  Sortie du Buzzer
byte rel_ld = 12;//  Sortie du relais de commande de charge (si monté) 

#include <TM1637Display.h> //Gestion CI de l'afficheur
#define CLK 3 //Synchro horloge de l'afficheur
#define DIO 2 //Données de l'afficheur 
#include <EEPROM.h> // Reservation d'espace dans l'EEPROM

TM1637Display display(CLK, DIO); // Raccordement Afficheur

int n = 0; //Variable de boucle du beep
int us,um; // variables Minutes Secondes 
int tm_Rec; // Variable du temps sauvegardé

bool clkState  = LOW; //Etat impulsion encodeur
bool clkLast  = HIGH;  //Etat dernière impulsion encodeur
bool swState  = LOW;  //Etat interpuls encodeur
bool swLast  = LOW;  //Etat dernière interpuls encodeur



void setup() {
  pinMode(sw_dwn, INPUT); //Direction et attribution des pins
  pinMode(sw_up, INPUT);
  pinMode(sw_sel, INPUT);
  pinMode(power_pin, OUTPUT);
  pinMode(buz_beep, OUTPUT);
  pinMode(rel_ld, OUTPUT);
  digitalWrite (power_pin, HIGH);   // Demarage automaintien alimentation!
  display.setBrightness(5);  //Réglage contraste afficheur
  EEPROM.get(05,us); // Adresse des secondes mémorisée en EEprom 
  EEPROM.get(10,um); // Adresse des minutes mémorisée en EEprom 
  display.showNumberDec(us+(100*um)); // Affichage du temps enregistré
  delay(1000);
    if (digitalRead(sw_sel)==HIGH) {   // si le temp enregistré convient, on garde le doigt sur le bouton
    decompt();  //Et on saute au décomptage !
  }
  delay(2000); 
  us = 0; // Si non après deux secondes RAZ des minutes & secondes et à sélectioner avec l'encodeur
  um = 0; 
}


void loop() {
clkState = digitalRead(sw_dwn);  // Suivant sens de rotation 
  if ((clkLast == LOW) && (clkState == HIGH)) {  
    if (digitalRead(sw_up) == HIGH) {
         um++;  //incrémentation de minutes 

       } 
       else {
         us++;  //incrémentation de secondes 
         if ( us > 59 ) {  // limitation a 59"
          us = 59;
         }
       }
     display.showNumberDec(us+(100*um)); // Affichage minutes et secondes
     delay(20);
   }

clkLast = clkState; // mémorisation de l'ancienne position encodeur

  if (digitalRead(sw_sel)==HIGH) {  // Quand le temps est correcte on appui et on va commencer à decompter
    digitalWrite (rel_ld, HIGH);  // On fait tirer le relais de la charge si il est monté 
    decompt();
  }
}

void decompt() { //Sous-programme de décomptage
   if (us==0)  {
      um --;  // Décrementation des minutes si seconde egal zero
      us = 59; // Et remise seconde à 59
    }
us--;
display.showNumberDec(us+(100*um)); // Affichage minutes & secondes restant
delay (996); // Ajustement du temps de boucle calculs pris en compte
  if (digitalRead(sw_sel)==HIGH) { //Mémorisation du temps si appui sur le bouton
    EEPROM.put(05, us);  // Ecrit les secondes en EEprom 
      EEPROM.put(10, um);  // Ecrit les minutes en EEprom
  }
  if ((us+(100*um))== 0){  // détection de la fin du décomptage
   beep();  // Saut au Beep si time égal zero
  }
  if ((us+(100*um)) > 100){  // Si ce n'est pas la dernière minute 
   display.setBrightness(1);  // réduction de la luminosite
  }
  else {
    display.setBrightness(5);
  }
decompt(); // Et on boucle !
}


void beep() {  // Ti-Ti-Ti-Taaaaa ! quand c'est fini
  digitalWrite (rel_ld, LOW);  // Coupure du relais de commande de charge
     for (int n=0; n <= 3; n++){
      digitalWrite (buz_beep, HIGH);
        delay (200);
      digitalWrite (buz_beep, LOW);
    delay (200);
   } 
digitalWrite (buz_beep, HIGH);
delay (700);
digitalWrite (buz_beep, LOW);
pwr_off();  // Saut à la coupure d'alim
}

void pwr_off() {
  digitalWrite (power_pin, LOW); // Coupure du relais d'automaintien d'alimentation

}
